;Program compiled by Great Cow BASIC (0.98.06 2019-06-12 (Windows 32 bit))
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F675, r=DEC
#include <P12F675.inc>
 __CONFIG _CP_OFF & _MCLRE_ON & _WDTE_OFF & _INTRC_OSC_NOCLKOUT

;********************************************************************************

;Set aside memory locations for variables
ADREADPORT	EQU	45
ADTEMP	EQU	46
CMCOM	EQU	47
CNT	EQU	48
DELAYTEMP	EQU	32
DELAYTEMP2	EQU	33
LIDO	EQU	49
LIDO_H	EQU	50
READAD10	EQU	51
READAD10_H	EQU	52
SYSBYTETEMPX	EQU	32
SYSDIVLOOP	EQU	36
SYSDIVMULTA	EQU	39
SYSDIVMULTA_H	EQU	40
SYSDIVMULTB	EQU	43
SYSDIVMULTB_H	EQU	44
SYSDIVMULTX	EQU	34
SYSDIVMULTX_H	EQU	35
SYSTEMP1	EQU	53
SYSWAITTEMP10US	EQU	37
SYSWAITTEMPMS	EQU	34
SYSWAITTEMPMS_H	EQU	35
SYSWAITTEMPUS	EQU	37
SYSWAITTEMPUS_H	EQU	38
SYSWORDTEMPA	EQU	37
SYSWORDTEMPA_H	EQU	38
SYSWORDTEMPB	EQU	41
SYSWORDTEMPB_H	EQU	42
SYSWORDTEMPX	EQU	32
SYSWORDTEMPX_H	EQU	33
TEMPO	EQU	54
TEMPO_H	EQU	55
WAUX	EQU	56
WAUX_H	EQU	57

;********************************************************************************

;Alias variables
ALLANSEL	EQU	159
SYSREADAD10WORD	EQU	51
SYSREADAD10WORD_H	EQU	52

;********************************************************************************

;Vectors
	ORG	0
	pagesel	BASPROGRAMSTART
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;*******************************************************************************
;SALVA BATERIA EM MULTITESTER
;C/ PIC12F675
;AUTOR: CLAUDIO LARIOS
;DATA:04/07/2020
;Objetivo: Desligar multitester aps um perodo de tempo ajustado em um
;potencimetro.
;Este perodo tem a faixa de 1 segundo at 15 minutos
;Emite um 'bip' quando est faltando 15 segundos para acabar o tempo.
;Uso didtico
;Este arquivo  parte integrante do Picsource
;*******************************************************************************/
;#include <12F675.h>
;#device adc=10
;#use delay(clock=4000000)
;#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, MCLR, PUT, BROWNOUT
;#use fast_io(a)
;//bytes
;#byte  trisio = 0x85
;#byte  gpio   = 0x05
;#bit   out    = 0x5.5  //pino 2
;#bit   buzzer = 0x5.4  //pino 3
;#define mosfet     GPIO.5 'pino 2
;Dir     mosfet out
	banksel	TRISIO
	bcf	TRISIO,5
;#define buzzer  GPIO.4 'pino 3
;Dir     buzzer out
	bcf	TRISIO,4
;Dir     GPIO.2 In  'ENTRADA DO POTENCIMETRO
	bsf	TRISIO,2
;variveis globais
;Dim lido as word: lido = 0
	clrf	LIDO
	clrf	LIDO_H
;Dim waux as word: waux = 0
	clrf	WAUX
	clrf	WAUX_H
;Dim tempo as word: tempo = 0
	clrf	TEMPO
	clrf	TEMPO_H
;Dim cnt as byte: cnt = 0
	clrf	CNT
;#define VALOR_BIP 15 ' 15 segundos aprox.
;*******************************************************************************
;ROTINA MAIN
;*******************************************************************************/
;setup_adc_ports(sAN2 | VSS_VDD);  //seleciona AN2 e 5v como referncia
;setup_adc(ADC_CLOCK_DIV_8 );// ajusta o clock do adc
;set_adc_channel(2); //ajusta para o pino 5 (AN2)
;setup_counters(RTCC_INTERNAL,RTCC_DIV_1);
;setup_timer_1(T1_DISABLED);//desliga timer 1
;setup_comparator(NC_NC_NC_NC);//desliga comparadores
;setup_vref(FALSE);//desliga vref
;CMCOM = 7
	movlw	7
	movwf	CMCOM
;TRISIO = 0b001111;//ajusta entradas e sadas
	movlw	15
	movwf	TRISIO
;GPIO = 0b10000;//saida do transistor pnp=1 e o restante =0
	movlw	16
	banksel	GPIO
	movwf	GPIO
;*******************************************************************************
;LAO PRINCIPAL DE REPETIO
;*******************************************************************************/
;do
SysDoLoop_S1
;lido = 0;// l valor da tenso de entrada do pino 5
	clrf	LIDO
	clrf	LIDO_H
;soma  10 leituras sucessivas
;for cnt = 1 to 10
	clrf	CNT
SysForLoop1
	incf	CNT,F
;lido = lido + ReadAD10(AN2)
	movlw	2
	movwf	ADREADPORT
	call	FN_READAD104
	movf	SYSREADAD10WORD,W
	addwf	LIDO,F
	movf	SYSREADAD10WORD_H,W
	btfsc	STATUS,C
	incfsz	SYSREADAD10WORD_H,W
	addwf	LIDO_H,F
;next
	movlw	10
	subwf	CNT,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;lido = lido / 10' obtm a mdia das ultimas 10 leituras
	movf	LIDO,W
	movwf	SysWORDTempA
	movf	LIDO_H,W
	movwf	SysWORDTempA_H
	movlw	10
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysDivSub16
	movf	SysWORDTempA,W
	movwf	LIDO
	movf	SysWORDTempA_H,W
	movwf	LIDO_H
;if(lido < VALOR_BIP)then lido = VALOR_BIP 'valor mnimo
	movf	LIDO,W
	movwf	SysWORDTempA
	movf	LIDO_H,W
	movwf	SysWORDTempA_H
	movlw	15
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysCompLessThan16
	btfss	SysByteTempX,0
	goto	ENDIF2
	movlw	15
	movwf	LIDO
	clrf	LIDO_H
ENDIF2
;tempo = lido + 1
	movlw	1
	addwf	LIDO,W
	movwf	TEMPO
	movf	LIDO_H,W
	movwf	TEMPO_H
	movlw	0
	btfsc	STATUS,C
	movlw	0 + 1
	addwf	TEMPO_H,F
;do
SysDoLoop_S2
;tempo = tempo - 1
	movlw	1
	subwf	TEMPO,F
	movlw	0
	btfss	STATUS,C
	movlw	0 + 1
	subwf	TEMPO_H,F
;if(tempo = 0)then
	movf	TEMPO,W
	movwf	SysWORDTempA
	movf	TEMPO_H,W
	movwf	SysWORDTempA_H
	clrf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysCompEqual16
	btfss	SysByteTempX,0
	goto	ENDIF3
;apito longo indicando o desligamento
;for waux=0 to 1500
	movlw	255
	movwf	WAUX
	movwf	WAUX_H
SysForLoop2
	incf	WAUX,F
	btfsc	STATUS,Z
	incf	WAUX_H,F
;buzzer=1;
	bsf	GPIO,4
;wait 277 us 'delay us(277);
	movlw	92
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
;buzzer = 0;
	bcf	GPIO,4
;wait 277 us 'delay us(277);
	movlw	92
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
;next
	movf	WAUX,W
	movwf	SysWORDTempA
	movf	WAUX_H,W
	movwf	SysWORDTempA_H
	movlw	220
	movwf	SysWORDTempB
	movlw	5
	movwf	SysWORDTempB_H
	call	SysCompLessThan16
	btfsc	SysByteTempX,0
	goto	SysForLoop2
SysForLoopEnd2
;mosfet = 1 'desliga transistor pnp
	bsf	GPIO,5
;Sleep ' para o programa
	sleep
;end if
ENDIF3
;5 bips curtos 15 segundos antes de acabar o tempo
;if(tempo = VALOR_BIP)then
	movf	TEMPO,W
	movwf	SysWORDTempA
	movf	TEMPO_H,W
	movwf	SysWORDTempA_H
	movlw	15
	movwf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysCompEqual16
	btfss	SysByteTempX,0
	goto	ENDIF4
;for cnt=0 to 4
	movlw	255
	movwf	CNT
SysForLoop3
	incf	CNT,F
;for waux=0 to 300
	movlw	255
	movwf	WAUX
	movwf	WAUX_H
SysForLoop4
	incf	WAUX,F
	btfsc	STATUS,Z
	incf	WAUX_H,F
;buzzer=1
	bsf	GPIO,4
;wait 277 us 'delay
	movlw	92
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
;buzzer=0;
	bcf	GPIO,4
;wait 277 us 'delay
	movlw	92
	movwf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
;next
	movf	WAUX,W
	movwf	SysWORDTempA
	movf	WAUX_H,W
	movwf	SysWORDTempA_H
	movlw	44
	movwf	SysWORDTempB
	movlw	1
	movwf	SysWORDTempB_H
	call	SysCompLessThan16
	btfsc	SysByteTempX,0
	goto	SysForLoop4
SysForLoopEnd4
;wait 50 ms 'delay
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;next
	movlw	4
	subwf	CNT,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;end if
ENDIF4
;wait 1000 ms ' delay
	movlw	232
	movwf	SysWaitTempMS
	movlw	3
	movwf	SysWaitTempMS_H
	call	Delay_MS
;loop'
	goto	SysDoLoop_S2
SysDoLoop_E2
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

Delay_10US
D10US_START
	movlw	2
	movwf	DELAYTEMP
DelayUS0
	decfsz	DELAYTEMP,F
	goto	DelayUS0
	decfsz	SysWaitTemp10US, F
	goto	D10US_START
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	142
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	1
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

INITSYS
;Resolve OSCCAL calibration
;GCB does not load saved calibration data into OSCCAL register on Baseline PIC. Therefore the FOSC is inaccurate when using internal RC oscillator.
;Solution:  Add following as the FIRST lines in the INITSYS sub in the System.h file
;This loads the saved calibration data from the last flash memory location at POR or any time the chip is reset.
;CALL 0x3ff
	call	1023
;movwf osccal
	banksel	OSCCAL
	movwf	OSCCAL
;Set up internal oscillator
;Handle OSCCON1 register for parts that have this register
;Ensure all ports are set for digital I/O and, turn off A/D
;SET ADFM OFF
	banksel	ADCON0
	bcf	ADCON0,ADFM
;Switch off A/D Var(ADCON0)
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;Commence clearing any ANSEL variants in the part
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;End clearing any ANSEL variants in the part
;Turn off comparator - this is the default setting
;CMCON = 7
	movlw	7
	banksel	CMCON
	movwf	CMCON
;Turn off all ports
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

;Overloaded signature: BYTE:
FN_READAD104
;Always RIGHT justified
;SET ADFM ON
	bsf	ADCON0,ADFM
;Do conversion
;LLReadAD 0
;Code for PICs with newer A/D (with ANSEL register)
;Dim AllANSEL As Byte Alias ANSEL
;AllANSEL = 0
	banksel	ALLANSEL
	clrf	ALLANSEL
;ADTemp = ADReadPort + 1
	incf	ADREADPORT,W
	movwf	ADTEMP
;Set C On
	bsf	STATUS,C
;Do
SysDoLoop_S3
;Rotate AllANSEL Left
	rlf	ALLANSEL,F
;decfsz ADTemp,F
	decfsz	ADTEMP,F
;Loop
	goto	SysDoLoop_S3
SysDoLoop_E3
;Set conversion clock - improved to handle ADCS2
;SET ADCS2 OFF
	bcf	ANSEL,ADCS2
;SET ADCS1 OFF
	bcf	ANSEL,ADCS1
;SET ADCS0 ON
	bsf	ANSEL,ADCS0
;Choose port
;SET CHS0 OFF
	banksel	ADCON0
	bcf	ADCON0,CHS0
;SET CHS1 OFF
	bcf	ADCON0,CHS1
;IF ADReadPort.0 On Then Set CHS0 On
	btfsc	ADREADPORT,0
	bsf	ADCON0,CHS0
;IF ADReadPort.1 On Then Set CHS1 On
	btfsc	ADREADPORT,1
	bsf	ADCON0,CHS1
;Enable A/D
;SET ADON ON
	bsf	ADCON0,ADON
;Acquisition Delay
;Wait AD_Delay
	movlw	2
	movwf	SysWaitTemp10US
	call	Delay_10US
;Read A/D
;SET GO_NOT_DONE ON
	bsf	ADCON0,GO_NOT_DONE
;nop
	nop
;Wait While GO_NOT_DONE ON
SysWaitLoop1
	btfsc	ADCON0,GO_NOT_DONE
	goto	SysWaitLoop1
;Switch off A/D
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;Clear whatever ANSEL variants the chip has
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;Write output
;ReadAD10 = ADRESL
	movf	ADRESL,W
	movwf	READAD10
	clrf	READAD10_H
;ReadAD10_H = ADRESH
	banksel	ADRESH
	movf	ADRESH,W
	movwf	READAD10_H
;Put A/D format back to normal
;SET ADFM OFF
	bcf	ADCON0,ADFM
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;Test low, exit if false
;movf SysWordTempA, W
	movf	SYSWORDTEMPA, W
;subwf SysWordTempB, W
	subwf	SYSWORDTEMPB, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;Test high, exit if false
;movf SysWordTempA_H, W
	movf	SYSWORDTEMPA_H, W
;subwf SysWordTempB_H, W
	subwf	SYSWORDTEMPB_H, W
;btfss STATUS, Z
	btfss	STATUS, Z
;return
	return
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;Test High, exit if more
;movf SysWordTempA_H,W
	movf	SYSWORDTEMPA_H,W
;subwf SysWordTempB_H,W
	subwf	SYSWORDTEMPB_H,W
;btfss STATUS,C
	btfss	STATUS,C
;return
	return
;Test high, exit true if less
;movf SysWordTempB_H,W
	movf	SYSWORDTEMPB_H,W
;subwf SysWordTempA_H,W
	subwf	SYSWORDTEMPA_H,W
;btfss STATUS,C
	btfss	STATUS,C
;goto SCLT16True
	goto	SCLT16TRUE
;Test Low, exit if more or equal
;movf SysWordTempB,W
	movf	SYSWORDTEMPB,W
;subwf SysWordTempA,W
	subwf	SYSWORDTEMPA,W
;btfsc STATUS,C
	btfsc	STATUS,C
;return
	return
SCLT16TRUE
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************

SYSDIVSUB16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysWordTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysWordTempA
	movf	SYSWORDTEMPA,W
	movwf	SYSDIVMULTA
	movf	SYSWORDTEMPA_H,W
	movwf	SYSDIVMULTA_H
;SysDivMultB = SysWordTempB
	movf	SYSWORDTEMPB,W
	movwf	SYSDIVMULTB
	movf	SYSWORDTEMPB_H,W
	movwf	SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX
	clrf	SYSDIVMULTX_H
;Avoid division by zero
;if SysDivMultB = 0 then
	movf	SYSDIVMULTB,W
	movwf	SysWORDTempA
	movf	SYSDIVMULTB_H,W
	movwf	SysWORDTempA_H
	clrf	SysWORDTempB
	clrf	SysWORDTempB_H
	call	SysCompEqual16
	btfss	SysByteTempX,0
	goto	ENDIF11
;SysWordTempA = 0
	clrf	SYSWORDTEMPA
	clrf	SYSWORDTEMPA_H
;exit sub
	return
;end if
ENDIF11
;Main calc routine
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP
SYSDIV16START
;set C off
	bcf	STATUS,C
;Rotate SysDivMultA Left
	rlf	SYSDIVMULTA,F
	rlf	SYSDIVMULTA_H,F
;Rotate SysDivMultX Left
	rlf	SYSDIVMULTX,F
	rlf	SYSDIVMULTX_H,F
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W
	subwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfss	STATUS,C
	incfsz	SYSDIVMULTB_H,W
	subwf	SYSDIVMULTX_H,F
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0
;If C Off Then
	btfsc	STATUS,C
	goto	ENDIF12
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W
	addwf	SYSDIVMULTX,F
	movf	SYSDIVMULTB_H,W
	btfsc	STATUS,C
	incfsz	SYSDIVMULTB_H,W
	addwf	SYSDIVMULTX_H,F
;End If
ENDIF12
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F
;goto SysDiv16Start
	goto	SYSDIV16START
;SysWordTempA = SysDivMultA
	movf	SYSDIVMULTA,W
	movwf	SYSWORDTEMPA
	movf	SYSDIVMULTA_H,W
	movwf	SYSWORDTEMPA_H
;SysWordTempX = SysDivMultX
	movf	SYSDIVMULTX,W
	movwf	SYSWORDTEMPX
	movf	SYSDIVMULTX_H,W
	movwf	SYSWORDTEMPX_H
	return

;********************************************************************************


 END
