/*******************************************************************************

    SALVA BATERIA EM MULTITESTER  V2
  
   (verso sem uso do driver pnp para o mosfet)
    C/ PIC12F675


    AUTOR: CLAUDIO LARIOS

    DATA:04/07/2020

    Objetivo: Desligar multitester aps um perodo de tempo ajustado em um
    potencimetro.
    Este perodo tem a faixa de 1 segundo at 15 minutos
    Emite um 'bip' quando est faltando 15 segundos para acabar o tempo.
    Uso didtico

    Este arquivo  parte integrante do Picsource

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <xc.h>

#define _XTAL_FREQ  4000000  //xtal 4Mhz

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG
#pragma config FOSC = INTRCIO   // Oscillator Selection bits (INTOSC oscillator: I/O function on RA4/OSC2/CLKOUT pin, I/O function on RA5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON      // RA3/MCLR pin function select (RA3/MCLR pin function is digital I/O, MCLR internally tied to VDD)
#pragma config BOREN = OFF      // Brown-out Detect Enable bit (BOD disabled)
#pragma config CP = OFF         // Code Protection bit (Program Memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)


//#byte  trisio = 0x85
//#byte  gpio   = 0x05
#define   mosfet   GPIO5  //pino 2
#define   buzzer   GPIO4  //pino 3

//variveis globais

int lido=0,waux=0,tempo=0;
char  cnt;


#define VALOR_BIP 15 // 15 seg aprox.

/*******************************************************************************
          ROTINA MAIN
*******************************************************************************/

void main() {
    
   CMCON = 7;//desliga comparadores
   ANSEL = 0B00010100;//AN2 clock/8   
   TRISIO = 0b001111;//ajusta entradas e sadas
   GPIO = 0b00000;//saidas todas desligadas
   ADCON0 = 0B10001001;//liga ADC canal AN2
   __delay_us(255);
   
   mosfet=1;//liga mosfet

   lido = 0;// l valor da tenso de entrada do pino 5
 
   
   for(cnt=0;cnt<5;cnt++){//soma mais 5 leituras
     GO_DONE = 1;
     while(GO_DONE);
     lido = lido +  (int) (ADRESH<<8|ADRESL);  
     __delay_us(100);
   }
   lido = lido / 5;//mdia das ultimas 5 leituras
   
    
   if(lido<VALOR_BIP) lido = VALOR_BIP;//valor mnimo

   

   tempo=lido + 1;
/*******************************************************************************
           LOOP PRINCIPAL DE REPETIO
*******************************************************************************/

    for(;;){


       tempo--;

       if(tempo == 0){
          
          for(waux=0;waux<1500;waux++){//apito longo indicando o desligamento
            buzzer=1;
            __delay_us(277);
            buzzer=0;
            __delay_us(277);
          }
          mosfet=0;//desliga mosfet
          SLEEP();//para o programa
        }



      if(tempo == VALOR_BIP){//5 bips curtos 15 segundos antes de acabar o tempo
        for(cnt=0; cnt<5;cnt++){
          for(waux=0;waux<300;waux++){
           buzzer=1;
           __delay_us(277);
           buzzer=0;
           __delay_us(277);
          }
          __delay_ms(50);
        }

      }

      __delay_ms(1000);
    }//for(;;)1


}//void main()
